Notice: In order to edit this ticket you need to be either: a Product Owner, The owner or the reporter of the ticket, or, in case of a Task not yet assigned, a team_member"

Task #5252 (new)

Opened 9 years ago

Last modified 4 years ago

RFE: Improved cancellation options

Reported by: jamoore Owned by:
Priority: minor Milestone: FacilityManagers
Component: Insight Version: OMERO-5.2.0
Keywords: n.a. Cc:
Resources: n.a. Referenced By: n.a.
References: n.a. Remaining Time: 0.25d
Sprint: n.a.

Description (last modified by jmoore)

Current things I'd like to do:

  1. cancel the current image which is "analyzing"
  2. cancel all the items in the current tab
  3. cancel all tabs.

Especially if we implement 1. above, then it will become a race to cancel all the other files before they also start importing. Perhaps a button, "pause all imports" would work similarly to 3. above.

See also: #5426. The already implemented SignalHandler would prevent the close warnings from occuring, allowing for a cleaner cleanup.

Change History (20)

comment:1 Changed 9 years ago by jburel

To implement correctly the cancellation, you should have an "Import call back" similar to delete or script.

  1. Is implemented that the cancel button.
  2. Can easily be done: actually 2 used to behave like 3.

comment:2 Changed 9 years ago by jmoore

Re: 2 there seem to be some cases where the "cancel" is not yet activated. Perhaps when scanning for candidates? This is most notable for slow setId methods. See #5251.

comment:3 Changed 9 years ago by jburel

The cancel is activated only if there are imports not yet started

comment:4 Changed 9 years ago by jburel

  • Remaining Time set to 0.2
  • Sprint set to 2011-05-19 (12)

Going to implement 3 i.e. cancel all tabs.

For ongoing import, need to review strategy see #5253

comment:5 Changed 9 years ago by jburel

  • Status changed from new to accepted

comment:6 Changed 9 years ago by jburel <j.burel@…>

(In [6a3607fea1a45a2adaa01701a26a9f8d305fbf09/ome.git] on branch develop) Prepare import for various cancel options (see #5252)

comment:7 Changed 9 years ago by jburel

  • Owner jburel deleted
  • Status changed from accepted to new

comment:8 Changed 9 years ago by jburel

  • Owner set to jburel

Schedule discussion: Josh+J-M

comment:9 Changed 9 years ago by jmoore

  • Owner changed from jburel to jmoore
  • Status changed from new to accepted

After a discussion with Jean-Marie, we decided to add a ImportCancellation exception so that ImportLibrary.importImage can be told to exit. Any observer can raise the exception during IObserver.update(). Any created pixels will be added to the exception and then it will be re-thrown, so ImportLibrary clients can clean up if desired.

comment:10 Changed 9 years ago by jmoore

Here's what the logic looks like from the CLI:

$ bin/omero import DSC_3409.NEF
2011-05-19 12:42:59,414 0          [      main] INFO          ome.formats.importer.ImportConfig  - OMERO Version: 4.3.0-DEV
2011-05-19 12:42:59,420 6          [      main] INFO          ome.formats.importer.ImportConfig  - Bioformats version: 4.3-DEV revision: 330dd7f date: 18 May 2011
2011-05-19 12:42:59,428 14         [      main] INFO   formats.importer.cli.CommandLineImporter  - Log levels -- Bio-Formats: ERROR OMERO.importer: INFO
2011-05-19 12:42:59,767 353        [      main] INFO      ome.formats.importer.ImportCandidates  - Depth: 4 Metadata Level: MINIMUM
2011-05-19 12:43:01,263 1849       [      main] INFO      ome.formats.importer.ImportCandidates  - 1 file(s) parsed into 1 group(s) with 1 call(s) to setId in 1490ms. (1495ms total) [0 unknowns]
2011-05-19 12:43:01,355 1941       [      main] INFO       ome.formats.OMEROMetadataStoreClient  - Attempting initial SSL connection to localhost:4064
2011-05-19 12:43:02,171 2757       [      main] INFO       ome.formats.OMEROMetadataStoreClient  - Insecure connection requested, falling back
2011-05-19 12:43:03,499 4085       [      main] INFO         ome.formats.importer.ImportLibrary  - Metadata only import? false
2011-05-19 12:43:03,499 4085       [      main] INFO         ome.formats.importer.ImportLibrary  - Archiving enabled? false
2011-05-19 12:43:03,500 4086       [      main] INFO         ome.formats.importer.ImportLibrary  - Reader is not of HCS domain, use metafile: true
2011-05-19 12:43:03,584 4170       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - BEGIN_POST_PROCESS
2011-05-19 12:43:03,595 4181       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - END_POST_PROCESS
2011-05-19 12:43:03,595 4181       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - BEGIN_SAVE_TO_DB
2011-05-19 12:43:03,748 4334       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - END_SAVE_TO_DB
2011-05-19 12:43:03,759 4345       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - DATASET_STORED
2011-05-19 12:43:04,034 4620       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:04,362 4948       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:04,632 5218       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:04,875 5461       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:05,142 5728       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:05,390 5976       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:05,636 6222       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:05,884 6470       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:06,148 6734       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:06,420 7006       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:06,687 7273       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:06,958 7544       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:07,235 7821       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:07,534 8120       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:08,012 8598       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:08,377 8963       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:08,842 9428       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:09,363 9949       [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
2011-05-19 12:43:09,760 10346      [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
^C2011-05-19 12:43:09,824 10410      [NT handler] INFO   formats.importer.cli.CommandLineImporter  - INT: Shutdown requested. Count = 1
2011-05-19 12:43:10,240 10826      [      main] INFO   ormats.importer.cli.LoggingImportMonitor  - IMPORT_STEP Image: 0 Series: 0 Total Series: 1
Imported pixels after cancellation:
363
2011-05-19 12:43:10,967 11553      [      main] INFO      ome.formats.importer.cli.ErrorHandler  - IMPORT_CANCELLATION

comment:11 Changed 9 years ago by jburel

  • Sprint changed from 2011-05-19 (12) to 2011-06-02 (13)

Moved from sprint 2011-05-19 (12)

comment:12 Changed 9 years ago by jburel <j.burel@…>

(In [ec533e9cb377cc9ea1fd802b57eb8cf7d02bd3e3/ome.git] on branch develop) Review cancellation process at UI level (see #5252)

comment:13 Changed 9 years ago by jmoore

  • Owner changed from jmoore to cxallan
  • Remaining Time changed from 0.2 to 0.25

Chris said he had some ideas we should evaluate, but unfortunately we didn't get to that today. He is right that the changes to the CLI importer may be too large post-freeze, but the addition of the new exception shouldn't be too invasive if no one is calling ErrorHandler.setCancel(true).

comment:14 Changed 8 years ago by jburel

Having the cancellation will be ideal, but adding it now is probably not the best. It might be better to implement it when we do the refactoring of the import code cf. discussion J-M Josh yesterday. We should add a story under FS improvement or Importer improvement with tasks.

comment:15 Changed 8 years ago by jburel

  • Owner cxallan deleted
  • Status changed from accepted to new

comment:16 Changed 8 years ago by jburel

  • Milestone changed from OMERO-Beta4.3 to Unscheduled
  • Sprint 2011-06-02 (13) deleted

comment:17 Changed 8 years ago by jmoore

  • Description modified (diff)

comment:18 Changed 8 years ago by jburel

Referencing ticket #2118 has changed sprint.

comment:19 Changed 4 years ago by jburel

  • Milestone changed from Unscheduled to FacilityManagers
  • Version set to OMERO-5.2.0

comment:20 Changed 4 years ago by jburel

  • Cc saloynton removed
Note: See TracTickets for help on using tickets. You may also have a look at Agilo extensions to the ticket.

1.3.13-PRO © 2008-2011 Agilo Software all rights reserved (this page was served in: 0.170212 sec.)

We're Hiring!